GameMode = {}
GameMode.Start = true
GameMode.Pause = false
GameMode.Play = false
GameMode.GameOver = false
GameMode.Creative = false
canvas = love.graphics.newCanvas(800, 600)

-- Rectangle is drawn to the canvas with the regular/default alpha blend mode ("alphamultiply").

function loadGameMode()

    moonshine = require './libraries/moonshine'

    effect = moonshine(moonshine.effects.desaturate)
    effectGlow = moonshine(moonshine.effects.glow)
    

end

function GameMode:toggleCreative()

    if GameMode.Creative then
        GameMode.Pause = true
        GameMode.Creative = false
    else 
        for k, obj in pairs(GameMode) do
            if type(obj) ~= "function" then
                GameMode[k] = false
            end
        end
        GameMode.Creative = true
    end
end


function GameMode:start()
    if GameMode.Start then
        GameMode.Start = false
        GameMode.Play = true
    end
end

function GameMode:next()

    if GameMode.Start then
        GameMode.Start = false
        GameMode.Play = true
    elseif GameMode.Play then
        GameMode.Play = false
        GameMode.GameOver = true
    elseif GameMode.GameOver then
        GameMode.GameOver = false
        GameMode.Play = true
    end

end

function GameMode:gameover()

    GameMode.Play = false
    GameMode.GameOver = true

end

function GameMode:togglePause()

    if GameMode.Play then
        GameMode.Play = false
        GameMode.Pause = true
    elseif GameMode.Pause then
        GameMode.Play = true
        GameMode.Pause = false
    end

end

function GameMode:draw()
    if GameMode.Pause then

        effect(function()
            love.graphics.rectangle("line", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
            love.graphics.printf("PAUSE", love.graphics.newFont(80), 0, love.graphics.getHeight()*0.33, love.graphics.getWidth(), "center")
            love.graphics.printf("(press P to resume)", love.graphics.newFont(15), 0, love.graphics.getHeight()*0.33 + 85, love.graphics.getWidth(), "center")
          end)
    elseif GameMode.GameOver then

        effect(function()
            love.graphics.rectangle("line", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
            love.graphics.printf("YOU ARE DEAD", love.graphics.newFont(80), 0, love.graphics.getHeight()*0.33, love.graphics.getWidth(), "center")
            love.graphics.printf("press UP to start again", love.graphics.newFont(15), 0, love.graphics.getHeight()*0.33 + 85, love.graphics.getWidth(), "center")
          end)
    elseif GameMode.Start then

        effectGlow(function()
            love.graphics.rectangle("line", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
            love.graphics.printf("INFINITE UNREST", love.graphics.newFont(80), 0, love.graphics.getHeight()*0.63, love.graphics.getWidth(), "center")
            love.graphics.printf("press enter to start", love.graphics.newFont(15), 0, love.graphics.getHeight()*0.63 + 105, love.graphics.getWidth(), "center")
          end)

    else
        love.graphics.reset()
    end

end