assets = {}

startLeftWall = 50
levelWallY = 0
distanceBetweenWall = 350
thicknessWall = 150
heightBlock = love.graphics.getHeight() * 1

require('player')
require('spears')

spears = {}
startingMinDistBetweenSpears = playerBoxWidth * 4
mindistanceBetweenSpears = startingMinDistBetweenSpears


function resetAssets()

    for i=#assets, 3, -1 do
        assets[i]:destroy()
        table.remove(assets, i)
    end

    for i=#spears, 1, -1 do
        spears[i]:destroy()
        table.remove(spears, i)
    end

    mindistanceBetweenSpears = startingMinDistBetweenSpears


end

function loadWalls(levelZero) 

    spawnFixedAssets(levelZero)

end

function progressivelyReduceMinDistanceSpears()
    local floorDiv = (math.ceil(score / 50) - 1) -- div // not supported :(
    local reduceFactor = 1 - (0.1) * floorDiv
    mindistanceBetweenSpears = math.ceil(startingMinDistBetweenSpears * (reduceFactor))
    print("floorDiv" .. floorDiv)
    print("reduceFactor" .. reduceFactor)

end

function spawnRandomSpear()

    local mH = findMaxHeightAsset()

    spearsY = generateRandomSpearsSpawnPoints(mH)

    for i, y in ipairs(spearsY) do
        local spear = Spear:new(startLeftWall+thicknessWall, y)
        table.insert(spears, spear)
    end

end

function generateRandomSpearsSpawnPoints(maxHeight)

    local rest = heightBlock

    spawnsY = {}
    while rest > mindistanceBetweenSpears do
        local newY = math.random(mindistanceBetweenSpears, rest)
        --print("random(" .. mindistanceBetweenSpears .. "," .. rest .. ") = " .. newY)

        local lastSpawnY = maxHeight + heightBlock
        if #spawnsY > 0 then
            lastSpawnY = spawnsY[#spawnsY]
        end

        local newSpawnPoint = lastSpawnY - newY
        table.insert(spawnsY, newSpawnPoint)
        rest = rest - newY
        --print("maxHeight: " .. maxHeight)
        --print("newSpawnPoint: " .. newSpawnPoint)
        --print("rest: " .. rest)

    end

    return spawnsY

end

function spawnFixedAssets(startY)

    local leftWall = world:newRectangleCollider(
        startLeftWall,
        (startY-heightBlock),
        thicknessWall,
        heightBlock,
        {collision_class="WallL"}
    )

    local rightWall = world:newRectangleCollider(
        startLeftWall+thicknessWall+distanceBetweenWall,
        startY-heightBlock,
        thicknessWall,
        heightBlock,
        {collision_class="WallR"}
    )

    print("WALL X L " .. startLeftWall)
    print("WALL Y L " .. startY-heightBlock)
    print("WALL X R " .. startLeftWall+thicknessWall+distanceBetweenWall)
    print("WALL Y R " .. startY-heightBlock)

    leftWall:setType('static')
    rightWall:setType('static')

    table.insert(assets, leftWall)
    table.insert(assets, rightWall)


end


function findMaxHeightAsset()
    if #assets == 0 then
        return levelZero
    else
        local maxH = 0
        for i, obj in ipairs(assets) do
            maxH = math.min(obj:getY(), maxH)
        end

        return maxH 
    end
end

function updateWalls(player)
    if isWayUpperVoid(heightBlock) then
        local mh = findMaxHeightAsset() - heightBlock/2
        spawnFixedAssets(mh)
        spawnRandomSpear()
        progressivelyReduceMinDistanceSpears()

    end
end

function drawWalls()


    for i, obj in ipairs(spears) do
        Spear:draw(obj)
    end

    for i, obj in ipairs(assets) do

        local objX, objY = obj:getPosition()


        for stepX=50, 150, 50 do
            for stepY=objY-heightBlock/2, objY+heightBlock/2, 50 do
                love.graphics.draw(sprites.wall, stepX, stepY, nil, 0.2)
            end
        end
    
        for stepX=50 + distanceBetweenWall +  thicknessWall, 150 + distanceBetweenWall +  thicknessWall, 50 do
            for stepY=objY-heightBlock/2, objY+heightBlock/2, 50 do
                love.graphics.draw(sprites.wall, stepX, stepY, nil, 0.2)
            end
        end
    
        love.graphics.draw(sprites.torch, objX, objY+heightBlock+15, nil, 1.4, nil, 7)

    end


end
